apiVersion: workspace.devfile.io/v1alpha2
kind: DevWorkspaceTemplate
metadata:
  name: che-code-nodejs-web-app
spec:
  commands:
    - id: init-container-command
      apply:
        component: che-code-injector
  events:
    preStart:
      - init-container-command
  components:
    - name: che-code-runtime-description
      container:
        image: registry.redhat.io/devspaces/udi-rhel8:3.5
        command:
          - /checode/entrypoint-volume.sh
        volumeMounts:
          - name: checode
            path: /checode
        memoryLimit: 1024Mi
        memoryRequest: 256Mi
        cpuLimit: 500m
        cpuRequest: 30m
        endpoints:
          - name: che-code
            attributes:
              type: main
              cookiesAuthEnabled: true
              discoverable: false
              urlRewriteSupported: true
            targetPort: 3100
            exposure: public
            secure: false
            protocol: https
          - name: code-redirect-1
            attributes:
              discoverable: false
              urlRewriteSupported: false
            targetPort: 13131
            exposure: public
            protocol: http
          - name: code-redirect-2
            attributes:
              discoverable: false
              urlRewriteSupported: false
            targetPort: 13132
            exposure: public
            protocol: http
          - name: code-redirect-3
            attributes:
              discoverable: false
              urlRewriteSupported: false
            targetPort: 13133
            exposure: public
            protocol: http
      attributes:
        app.kubernetes.io/component: che-code-runtime
        app.kubernetes.io/part-of: che-code.eclipse.org
        controller.devfile.io/container-contribution: true
    - name: checode
      volume: {}
    - name: che-code-injector
      container:
        image: registry.redhat.io/devspaces/code-rhel8:3.5
        command:
          - /entrypoint-init-container.sh
        volumeMounts:
          - name: checode
            path: /checode
        memoryLimit: 256Mi
        memoryRequest: 32Mi
        cpuLimit: 500m
        cpuRequest: 30m
---
apiVersion: workspace.devfile.io/v1alpha2
kind: DevWorkspace
metadata:
  name: nodejs-web-app
spec:
  started: true
  template:
    components:
      - name: tools
        container:
          image: registry.redhat.io/devspaces/udi-rhel8:3.5
          endpoints:
            - exposure: public
              name: nodejs
              protocol: http
              targetPort: 3000
          memoryLimit: 1G
          mountSources: true
          volumeMounts:
            - name: npm
              path: /home/user/.npm
        attributes:
          controller.devfile.io/merge-contribution: true
      - name: npm
        volume:
          size: 1G
    commands:
      - id: 1-dependencies
        exec:
          label: Download dependencies
          component: tools
          workingDir: ${PROJECTS_ROOT}/web-nodejs-sample/app
          commandLine: npm install
          group:
            kind: build
      - id: 2-run
        exec:
          label: Run the web app
          component: tools
          workingDir: ${PROJECTS_ROOT}/web-nodejs-sample/app
          commandLine: nodemon app.js
          group:
            kind: run
      - id: 3-install-and-run
        exec:
          label: Run the web app (and download dependencies)
          component: tools
          workingDir: ${PROJECTS_ROOT}/web-nodejs-sample/app
          commandLine: npm install; nodemon app.js
          group:
            kind: run
      - id: 4-debug
        exec:
          label: Run the web app (debugging enabled)
          component: tools
          workingDir: ${PROJECTS_ROOT}/web-nodejs-sample/app
          commandLine: nodemon --inspect app.js
          group:
            kind: debug
            isDefault: true
      - id: 5-stopapp
        exec:
          label: Stop the web app
          component: tools
          commandLine: >-
            node_server_pids=$(pgrep -fx '.*nodemon (--inspect )?app.js' | tr
            "\\n" " ") && echo "Stopping node server with PIDs:
            ${node_server_pids}" &&  kill -15 ${node_server_pids} &>/dev/null &&
            echo 'Done.'
          group:
            kind: run
    projects:
      - name: web-nodejs-sample
        zip:
          location: '{{ INTERNAL_URL }}/resources/v2/web-nodejs-sample.zip'
  contributions:
    - name: editor
      kubernetes:
        name: che-code-nodejs-web-app
